module Mail
  module Gpg
    class << self  
      alias_method :encrypt_mailgpg, :encrypt

      def encrypt(cleartext_mail, options={})
        encrypted_mail = encrypt_mailgpg(cleartext_mail, options)
        if cleartext_mail.protected_headers_subject
          encrypted_mail.subject = cleartext_mail.protected_headers_subject
        end
        
        # The original "mail-gpg" gem does not handle the smtp envelope correctly
        # as it always sets the envelope "RCPT TO" to all addresses from the To, CC and BCC header.
        # This is a problem for the options keep_incoming_to and keep_incoming_cc as
        # we need the headers for the mail clients to display the original to and cc but only
        # send to one recipient on the list per mail. Thus we overwrite this setting here.
        if cleartext_mail.smtp_envelope_to
          encrypted_mail.smtp_envelope_to = cleartext_mail.smtp_envelope_to
        end

        encrypted_mail
      end
    end  
  end
end
